//prototypes - CW

typedef struct _dlink_node dlink_node;
typedef struct _dlink_list dlink_list;

struct _dlink_node
{
	void *data;
	dlink_node *prev;
	dlink_node *next;
};
  
struct _dlink_list
{
	dlink_node *head;
	dlink_node *tail;
	unsigned long length;
};

void dlinkAddHead(void *data, dlink_node *m, dlink_list *list);
void dlinkAddTail(void *data, dlink_node *m, dlink_list *list);
void dlinkAddBefore(dlink_node *b, void *data, dlink_node *m, dlink_list *list);
void dlinkAddBehind(dlink_node *b, void *data, dlink_node *m, dlink_list *list);
void dlinkDelete(dlink_node *m, dlink_list *list);
