//somekind of modified version of the stuff ircds use - CW

#include "dlink.h"

void dlinkAddHead(void *data, dlink_node *m, dlink_list *list)
{
	m->data = data;
	m->next = list->head;
	m->prev = 0;
	if (0 == list->tail)
		list->tail = m;
	else
	    if (list->head)
		list->head->prev = m;
	list->head = m; 
	list->length++;
}

void dlinkAddTail(void *data, dlink_node *m, dlink_list *list)
{
	m->data = data;
	m->next = 0;
	m->prev = list->tail;
	if (list->tail)
		list->tail->next = m;
	else
		list->head = m;
	list->tail = m;
	list->length++;
}

void dlinkAddBefore(dlink_node *b, void *data, dlink_node *m, dlink_list *list)
{
	if (b == list->head)
		dlinkAddHead(data, m, list);
	else
	{
		m->data = data;
		if (b->prev)
		    b->prev->next = m;
		m->prev = b->prev;
		b->prev = m; 
		m->next = b;
		list->length++;
	}
}

void dlinkAddBehind(dlink_node *b, void *data, dlink_node *m, dlink_list *list)
{
	if (b == list->tail)
		dlinkAddTail(data, m, list);
	else
	{
		m->data = data;
		if (b->next)
		    b->next->prev = m;
		m->next = b->next;
		b->next = m; 
		m->prev = b;
		list->length++;
	}
}

void dlinkDelete(dlink_node *m, dlink_list *list)
{
	if (m->next)
		m->next->prev = m->prev;
	else {
		list->tail = m->prev;
		if (m->prev)
		    m->prev->next = 0;
	}
	if (m->prev)
		m->prev->next = m->next;
	else {
		list->head = m->next;
		if (m->next)
		    m->next->prev = 0;
	}
	list->length--;
}

